## nx-libs-3.5.0.31-lite.tar.gz

=== Makefile ===
#!/usr/bin/make -f

INSTALL_DIR=install -d -m 755
INSTALL_FILE=install -m 644
INSTALL_PROGRAM=install -m 755
INSTALL_SYMLINK=ln -s -f
COPY_SYMLINK=cp -a
RM_FILE=rm -f
RM_DIR=rmdir -p --ignore-fail-on-non-empty

ETCDIR_NX   ?= /etc/nxagent
ETCDIR_X2GO ?= /etc/x2go
PREFIX      ?= /usr/local
BINDIR      ?= $(PREFIX)/bin
LIBDIR      ?= $(PREFIX)/lib
USRLIBDIR   ?= $(LIBDIR)
INCLUDEDIR  ?= $(PREFIX)/include
NXLIBDIR    ?= $(PREFIX)/lib/nx
X2GOLIBDIR  ?= $(PREFIX)/lib/x2go
CONFIGURE   ?= ./configure

SHELL:=/bin/bash

%:
	if test -f nxcomp/Makefile; then ${MAKE} -C nxcomp $@; fi
	if test -f nxproxy/Makefile; then ${MAKE} -C nxproxy $@; fi
	if test -d nx-X11; then \
	    if test -f nxcompext/Makefile; then ${MAKE} -C nxcompext $@; fi; \
	    if test -f nxcompshad/Makefile; then ${MAKE} -C nxcompshad $@; fi; \
	    if test -f nx-X11/Makefile; then ${MAKE} -C nx-X11 $@; fi; \
	fi

all: build

test:
	echo "No testing for NX (redistributed)"

build-lite:
	cd nxcomp && autoconf && (${CONFIGURE}) && ${MAKE}
	cd nxproxy && autoconf && (${CONFIGURE}) && ${MAKE}

build-full:
# in the full case, we rely on "magic" in the nx-X11 imake-based makefiles...
	cd nxcomp && autoconf
	cd nxcompext && autoconf
	cd nxcompshad && autoconf
	cd nx-X11 && ${MAKE} World
	cd nxproxy && autoconf && (${CONFIGURE}) && ${MAKE}

build:
	if ! test -d nx-X11; then \
	    ${MAKE} build-lite; \
	else \
	    ${MAKE} build-full; \
	fi

install:
	$(MAKE) install-lite
	[ ! -d nx-X11 ] || $(MAKE) install-full

install-lite:
	# install nxcomp library
	$(MAKE) -C nxcomp install

	# install nxproxy wrapper script
	$(INSTALL_DIR) $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) bin/nxproxy $(DESTDIR)$(BINDIR)

	# FIXME: the below install logic should work via nxproxy/Makefile.in
	# overriding for now...
	$(INSTALL_DIR) $(DESTDIR)$(NXLIBDIR)/bin
	$(INSTALL_PROGRAM) nxproxy/nxproxy $(DESTDIR)$(NXLIBDIR)/bin

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/man/man1/
	$(INSTALL_FILE) nxproxy/man/nxproxy.1 $(DESTDIR)$(PREFIX)/share/man/man1/
	gzip $(DESTDIR)$(PREFIX)/share/man/man1/*.1

install-full:
	for f in nxagent nxauth x2goagent; do \
	   $(INSTALL_PROGRAM) bin/$$f $(DESTDIR)$(BINDIR); done
	for d in nxcompext nxcompshad; do \
	   $(MAKE) -C $$d install; done

	$(INSTALL_DIR) $(DESTDIR)$(X2GOLIBDIR)/bin/
	cd $(DESTDIR)$(X2GOLIBDIR)/bin/ && ln -sf $(NXLIBDIR)/bin/nxagent x2goagent

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/pixmaps
	$(INSTALL_FILE) nx-X11/programs/Xserver/hw/nxagent/x2go.xpm $(DESTDIR)$(PREFIX)/share/pixmaps
	$(INSTALL_FILE) nx-X11/programs/Xserver/hw/nxagent/nxagent.xpm $(DESTDIR)$(PREFIX)/share/pixmaps

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/nx
	$(INSTALL_FILE) nx-X11/programs/Xserver/Xext/SecurityPolicy $(DESTDIR)$(PREFIX)/share/nx

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/x2go/versions
	$(INSTALL_FILE) VERSION.x2goagent $(DESTDIR)$(PREFIX)/share/x2go/versions

	$(INSTALL_DIR) $(DESTDIR)$(NXLIBDIR)/bin
	$(INSTALL_PROGRAM) nx-X11/programs/nxauth/nxauth $(DESTDIR)$(NXLIBDIR)/bin
	$(INSTALL_PROGRAM) nx-X11/programs/Xserver/nxagent $(DESTDIR)$(NXLIBDIR)/bin

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/man/man1/
	$(INSTALL_FILE) nx-X11/programs/Xserver/hw/nxagent/man/x2goagent.1 $(DESTDIR)$(PREFIX)/share/man/man1/
	$(INSTALL_FILE) nx-X11/programs/Xserver/hw/nxagent/man/nxagent.1 $(DESTDIR)$(PREFIX)/share/man/man1/
	$(INSTALL_FILE) nx-X11/programs/nxauth/nxauth.man $(DESTDIR)$(PREFIX)/share/man/man1/
	mv -f $(DESTDIR)$(PREFIX)/share/man/man1/nxauth.man $(DESTDIR)$(PREFIX)/share/man/man1/nxauth.1
	gzip $(DESTDIR)$(PREFIX)/share/man/man1/*.1

	# create a clean nx-X11/.build-exports space
	rm -Rf nx-X11/.build-exports
	mkdir -p nx-X11/.build-exports/include
	mkdir -p nx-X11/.build-exports/lib

	# copy headers (for libnx-x11-dev)
	cp -aL nx-X11/exports/include/* nx-X11/.build-exports/include

	# copy libs (for libnx-x11), we want the targets of the links
	. replace.sh; set -x; find nx-X11/exports/lib/ | grep -F ".so" | while read libpath; do \
	    libfile=$$(basename $$libpath); \
	    libdir=$$(dirname $$libpath); \
	    link=$$(readlink $$libpath); \
	\
	    mkdir -p "$$(string_rep "$$libdir" exports .build-exports)"; \
	    cp -a "$$(string_rep "$$libpath" "$$libfile" "$$link")" "$$(string_rep "$$libdir" exports .build-exports)"; \
	done;

	$(INSTALL_DIR) $(DESTDIR)$(USRLIBDIR)
	$(COPY_SYMLINK) nx-X11/.build-exports/lib/*.so* $(DESTDIR)$(USRLIBDIR)/

	. replace.sh; set -x; find nx-X11/.build-exports/include/ -type d | grep -v "include/X11/bitmaps" | \
	    while read dirname; do \
	        $(INSTALL_DIR) "$$(string_rep "$$dirname" nx-X11/.build-exports/include "$(DESTDIR)$(INCLUDEDIR)/nx")"; \
	        $(INSTALL_FILE) $${dirname}/*.h \
	                        "$$(string_rep "$$dirname" nx-X11/.build-exports/include "$(DESTDIR)$(INCLUDEDIR)/nx")"/ || true; \
	    done; \

	# Provide means for Xinerama support in NX/X2Go sessions. This
	# This also requires two post-install symlinks:
	# (DESTDIR)$(NXLIBDIR)/X11/Xinerama/libNX_X11.so.6 -> /usr/<libdir>/libX11.so.6
	# (DESTDIR)$(NXLIBDIR)/X11/Xinerama/libNX_Xext.so.6 -> /usr/<libdir>/libXext.so.6
	$(INSTALL_DIR) $(DESTDIR)$(NXLIBDIR)/X11/Xinerama
	$(INSTALL_SYMLINK) $(USRLIBDIR)/libNX_Xinerama.so.1 $(DESTDIR)$(NXLIBDIR)/X11/Xinerama/libXinerama.so.1

	$(INSTALL_DIR) $(DESTDIR)$(INCLUDEDIR)/nx/X11/bitmaps
	$(INSTALL_FILE) nx-X11/.build-exports/include/X11/bitmaps/* \
	                $(DESTDIR)$(INCLUDEDIR)/nx/X11/bitmaps/

	$(INSTALL_DIR) $(DESTDIR)/$(ETCDIR_NX)
	$(INSTALL_DIR) $(DESTDIR)/$(ETCDIR_X2GO)
	$(INSTALL_FILE) etc/keystrokes.cfg $(DESTDIR)/$(ETCDIR_NX)/
	$(INSTALL_FILE) etc/keystrokes.cfg $(DESTDIR)/$(ETCDIR_X2GO)/
	$(INSTALL_FILE) etc/rgb $(DESTDIR)$(ETCDIR_X2GO)/
	$(INSTALL_FILE) etc/rgb $(DESTDIR)$(ETCDIR_NX)/
	$(INSTALL_FILE) etc/nxagent.keyboard $(DESTDIR)$(ETCDIR_NX)/
	$(INSTALL_FILE) etc/x2goagent.keyboard $(DESTDIR)$(ETCDIR_X2GO)/

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/x2go
	$(INSTALL_SYMLINK) $(ETCDIR_X2GO)/rgb $(DESTDIR)$(PREFIX)/share/x2go/rgb

	$(INSTALL_DIR) $(DESTDIR)$(PREFIX)/share/nx
	$(INSTALL_SYMLINK) $(ETCDIR_NX)/rgb $(DESTDIR)$(PREFIX)/share/nx/rgb

uninstall:
	$(MAKE) uninstall-lite
	[ ! -d nx-X11 ] || $(MAKE) uninstall-full

uninstall-lite:
	if test -f nxcomp/Makefile; then ${MAKE} -C nxcomp $@; fi

	# uninstall nproxy wrapper script
	$(RM_FILE) $(DESTDIR)$(BINDIR)/nxproxy
	# FIXME: don't use uninstall rule in nxproxy/Makefile.in, let's do
        # it on our own for now...
	$(RM_FILE) $(DESTDIR)$(NXLIBDIR)/bin/nxproxy
	$(RM_DIR) $(DESTDIR)$(NXLIBDIR)/bin/
	$(RM_FILE) $(DESTDIR)$(PREFIX)/share/man/man1/*.1

uninstall-full:
	for f in nxagent nxauth x2goagent; do \
	    $(RM_FILE) $(DESTDIR)$(BINDIR)/$$f; done

	$(RM_FILE) $(DESTDIR)$(X2GOLIBDIR)/bin/x2goagent
	$(RM_DIR) $(DESTDIR)$(X2GOLIBDIR)/bin/

	if test -d nx-X11; then \
	    if test -f nxcompext/Makefile; then ${MAKE} -C nxcompext $@; fi; \
	    if test -f nxcompshad/Makefile; then ${MAKE} -C nxcompshad $@; fi; \
	    if test -f nx-X11/Makefile; then \
	        if test -d $(NXLIBDIR); then rm -rf $(NXLIBDIR); fi; \
	        if test -d $(INCLUDEDIR)/nx; then rm -rf $(INCLUDEDIR)/nx; fi; \
	    fi; \
	fi

=== debian/control ===
Source: nx-libs
Section: x11
Priority: extra
Maintainer: X2Go Developers <x2go-dev@lists.berlios.de>
Uploaders:
 Reinhard Tartler <siretart@tauware.de>,
 Mike Gabriel <mike.gabriel@das-netzwerkteam.de>,
 Oleksandr Shneyder <oleksandr.shneyder@obviously-nice.de>,
Build-Depends:
 debhelper (>= 7.0.50~),
 libpng-dev,
 libjpeg-dev,
 zlib1g-dev,
 quilt (>= 0.46-7~),
 libfontconfig1-dev,
 libfontenc-dev,
 libfreetype6-dev,
 libxmltok1-dev,
 libxml2-dev,
 autoconf,
 pkg-config,
 x11proto-core-dev,
 expat,
Build-Conflicts:
 x11proto-kb-dev,
 x11proto-randr-dev,
 x11proto-record-dev,
 x11proto-xinerama-dev,
Standards-Version: 3.9.6
Homepage: http://code.x2go.org/gitweb?p=nx-libs.git;a=summary
Vcs-Git: git://code.x2go.org/nx-libs.git
Vcs-Browser: http://code.x2go.org/gitweb?p=nx-libs.git;a=summary

Package: nx-x11-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11 (<< 2:3.5.0.29-0x2go2~),
        nxagent (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 (common files)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides all architecture-independent files for nx-X11.

Package: nx-x11proto-core-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 core wire protocol and auxiliary headers
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides development headers describing the wire protocol
 for the core nx-X11 protocol, and also provides a number of utility headers,
 used to abstract OS-specific functions.

Package: libnx-x11
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libnx-x11-6 (>= ${source:Version}), libnx-x11-6 (<< ${source:Version}.1), 
Description: nx-X11 client-side library (transitional dummy package)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package is a transitional dummy package and can be safely removed
 (inducing transition of libnx-x11 to libnx-x11-6).

Package: libnx-x11-6
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 nx-x11-common (>= ${source:Version}), nx-x11-common (<< ${source:Version}.1), 
Breaks: nxlibs (<= 3.5.1),
        libnx-x11 (<< 2:3.5.0.29-0x2go2~),
Replaces: nxlibs,
Description: nx-X11 client-side library
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides the core nx-X11 libraries customized for
 nxagent.

Package: libnx-x11-dev
Provides: libnx-x11-6-dev
Section: libdevel
Architecture: any
Breaks: nxlibs-dev (<=3.5.1),
Replaces: nxlibs-dev,
Depends:
 libnx-x11-6 (= ${binary:Version}),
 ${misc:Depends},
Description: nx-X11 client-side library (development headers)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides the development headers for the core nx-X11
 libraries customized for nxagent.

Package: libnx-x11-6-dbg
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libnx-x11-6 (= ${binary:Version}),
 ${misc:Depends},
Section: debug
Breaks: nx-x11-dbg (<< 2:3.5.0.29-0x2go2~),
Replaces: nx-x11-dbg,
Description: nx-X11 client-side library (debug package)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package contains debug symbols for the core nx-X11 libraries
 customized for nxagent.

Package: libnx-xau6
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11 (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 authorisation library
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides the main interface to the nx-X11 authorisation handling,
 which controls authorisation for X connections, both client-side and
 server-side.

Package: libnx-xau-dev
Provides: libnx-xau6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnx-xau6 (= ${binary:Version}),
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 authorisation library (development headers)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides the main interface to the nx-X11 authorisation handling,
 which controls authorisation for X connections, both client-side and
 server-side.
 .
 This package contains the development headers for this library.

Package: libnx-xau6-dbg
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libnx-xau6 (= ${binary:Version}),
 ${misc:Depends},
Section: debug
Breaks: nx-x11-dbg (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 authorisation library (debug package)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides the main interface to the nx-X11 authorisation handling,
 which controls authorisation for X connections, both client-side and
 server-side.
 .
 This package contains debug symbols for this library.

Package: libnx-xcomposite1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11 (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 Composite extension library
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xcomposite provides an X Window System client interface to the Composite
 extension to the X protocol
 .
 The Composite extension allows clients called compositing managers to control
 the final drawing of the screen. Rendering is done into an off-screen buffer.

Package: libnx-xcomposite-dev
Provides: libnx-xcomposite1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnx-xcomposite1 (= ${binary:Version}),
 nx-x11proto-composite-dev (= ${binary:Version}),
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 Composite extension library (development headers)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xcomposite provides an X Window System client interface to the Composite
 extension to the X protocol
 .
 The Composite extension allows clients called compositing managers to control
 the final drawing of the screen. Rendering is done into an off-screen buffer.
 .
 This package contains the development headers for this library.

Package: nx-x11proto-composite-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 Composite extension wire protocol
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides development headers describing the wire protocol
 for the Composite extension in nx-X11, used to let arbitrary client
 programs control drawing of the final image.

Package: libnx-xcomposite1-dbg
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libnx-xcomposite1 (= ${binary:Version}),
 ${misc:Depends},
Section: debug
Breaks: nx-x11-dbg (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 Composite extension library (debug package)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xcomposite provides an X Window System client interface to the Composite
 extension to the X protocol
 .
 The Composite extension allows clients called compositing managers to control
 the final drawing of the screen. Rendering is done into an off-screen buffer.
 .
 This package contains debug symbols for this library.

Package: libnx-xdamage1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11 (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 damaged region extension library
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xdamage provides an X Window System client interface to the DAMAGE
 extension to the X protocol.
 .
 The Damage extension provides for notification of when on-screen regions have
 been 'damaged' (altered)

Package: libnx-xdamage-dev
Provides: libnx-xdamage1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnx-xdamage1 (= ${binary:Version}),
 nx-x11proto-damage-dev (= ${binary:Version}),
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 damaged region extension library (development headers)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xdamage provides an X Window System client interface to the DAMAGE
 extension to the X protocol.
 .
 The Damage extension provides for notification of when on-screen regions have
 been 'damaged' (altered)
 .
 This package contains the development headers for this library.

Package: nx-x11proto-damage-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Breaks: nxlibs (<= 3.5.1),
        libnx-x11-dev (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 Damage extension wire protocol
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 This package provides development headers describing the wire protocol
 for the Damage extension in nx-X11, used to notify clients of changes
 made to particular areas.

Package: libnx-xdamage1-dbg
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libnx-xdamage1 (= ${binary:Version}),
 ${misc:Depends},
Section: debug
Breaks: nx-x11-dbg (<< 2:3.5.0.29-0x2go2~),
Description: nx-X11 damaged region extension library (debug package)
 NX is a software suite which implements very efficient
 compression of the X11 protocol. This increases performance when
 using X applications over a network, especially a slow one.
 .
 libNX_Xdamage provides an X Window System client interface to the DAMAGE
 extension to the X protocol.
 .
 The Damage extension provides for notification of when on-screen regions have
 been 'damaged' (altered)

=== debian/rules ===
#!/usr/bin/make -f

NULL =

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export LIBDIR = "/usr/lib/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)"
export INCLUDEDIR = "/usr/include/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)"

%:
	CONFIGURE="./configure --with-symbols --prefix=/usr --libdir=$(LIBDIR) --includedir=$(INCLUDEDIR)" dh $@ --with quilt

# before build, we will remove unused code / bundled libraries (keep this in sync with roll-tarball.sh)
UNUSED_FOLDERS           = "debian/CODE-REDUCTION_CLEANUP-UNUSED"
CLEANUP_FOLDERS          = "debian/CODE-REDUCTION_CLEANUP-BRUTAL"
UNNEEDED_BACKUPS         = "debian/CODE-REDUCTION_CLEANUP-BACKUPFILES"
PRESERVE_SYMLINKED_FILES = "debian/CODE-REDUCTION_PRESERVE-SYMLINKED"
PRESERVE_NEEDED_FILES    = "debian/CODE-REDUCTION_PRESERVE-NEEDED"
PRESERVE_INCLUDED_FILES  = "debian/CODE-REDUCTION_PRESERVE-INCLUDED"

override_dh_auto_clean:
	rm -Rf nx-X11/.build-exports
	dh_auto_clean

override_dh_clean:
	rm -f nx*/configure
	rm -f nx*/changelog
	rm -f doc/changelog
	rm -f nx-X11/programs/Xserver/hw/nxagent/changelog
	rm -f nx-X11/programs/nxauth/changelog
	if [ ! -f replace.sh ] && [ ! -h replace.sh ]; then ln -s debian/Makefile.replace.sh replace.sh; fi
	. ./replace.sh; set -x; ls debian/*.install.in | while read file; do rm -f $$(string_rep $$file .install.in .install); done
	rm -fR replace.sh Makefile bin etc/rgb VERSION.x2goagent etc/keystrokes.cfg etc/nxagent.keyboard etc/x2goagent.keyboard
	rm -f debian/libnx-xinerama1.postinst
	rm -fR .preserve/
	if [ -f nxcomp/.VERSION.NoMachine ]; then mv nxcomp/.VERSION.NoMachine nxcomp/VERSION; fi
	dh_clean

override_dh_installchangelog:

	### the doc/changelog file is the actual NX (redistributed) ChangeLog
	dh_installchangelog doc/changelog

override_dh_install:

	# handle builds for Debian squeeze (non multi-arch)
	. ./replace.sh; set -x; if [ -z "$(DEB_BUILD_MULTIARCH)" ]; then \
	    find debian/*.install.in | while read file; do \
	        cat $$file | sed -e 's#/\*/#/#g' > $$(string_rep $$file .install.in .install); \
	    done; \
	else \
	    find debian/*.install.in | while read file; do \
	        cat $$file > $$(string_rep $$file .install.in .install); \
	    done; \
	fi

	# remove static libs
	rm debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/libXcomp.a
	rm debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/libXcompshad.a

	# remove extras, GL, and other unneeded headers
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/GL/
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/bitmaps/
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/XInput.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/XK*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/*Xv*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xtrap*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/Print*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/XRes*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/record*.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86vmode.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86vmstr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86misc.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86dga1.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86dgastr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86dga.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86dga1str.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86mscstr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/dmxext.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/dmxproto.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/bigreqstr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xcmiscstr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/XIproto.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86bigfstr.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/xf86bigfont.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/extensions/XI.h
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/fonts/
	rm -R debian/tmp/usr/include/$(DEB_BUILD_MULTIARCH)/nx/X11/Xtrans/

	dh_install --fail-missing

override_dh_auto_install:
	PREFIX=/usr dh_auto_install -Smakefile

override_dh_auto_build:

	# create copies of upstream changelogs so that names apply to Debian policy...
	cp -a nx-X11/CHANGELOG nx-X11/changelog
	cp -a nxcomp/CHANGELOG nxcomp/changelog
	if [ -f nxcomp/VERSION ]; then cp nxcomp/VERSION nxcomp/.VERSION.NoMachine; fi
	cp -a nxcompext/CHANGELOG nxcompext/changelog
	cp -a nxcompshad/CHANGELOG nxcompshad/changelog
	cp -a nx-X11/programs/Xserver/hw/nxagent/CHANGELOG nx-X11/programs/Xserver/hw/nxagent/changelog
	cp -a nx-X11/programs/nxauth/CHANGELOG nx-X11/programs/nxauth/changelog
	cp -a nxproxy/CHANGELOG nxproxy/changelog
	ln -s debian/Makefile.nx-libs Makefile
	ln -s debian/Makefile.replace.sh replace.sh
	ln -s debian/wrappers bin
	mkdir -p etc/
	ln -s ../debian/keystrokes.cfg etc/keystrokes.cfg
	ln -s ../debian/rgb etc/rgb
	ln -s ../debian/nxagent.keyboard etc/nxagent.keyboard
	ln -s ../debian/x2goagent.keyboard etc/x2goagent.keyboard
	mkdir -p doc/
	ln -s ../debian/changelog doc/changelog
	ln -sf debian/VERSION VERSION.x2goagent
	ln -sf ../debian/VERSION nxcomp/VERSION

	# let's prep the libnx-xinerama1.postinst script with the value of the build systems's DEB_BUILD_MULTIARCH variable
	sed debian/libnx-xinerama1.postinst.in -e 's/#DEB_BUILD_MULTIARCH#/$(DEB_BUILD_MULTIARCH)/' > debian/libnx-xinerama1.postinst

	# make a copy of code to be preserved for build
	mkdir -p .preserve
	for path in `cat $(PRESERVE_SYMLINKED_FILES)` `cat $(PRESERVE_NEEDED_FILES)` `cat $(PRESERVE_INCLUDED_FILES)`; do \
	    if echo $$path | grep -E "^#.*"; then continue; fi; \
	    test -d $$path && mkdir -p .preserve/$$path || mkdir -p .preserve/$$(dirname $$path); \
	    cp -av $$path .preserve/$$path; \
	done

	# remove unused code / bundled libraries (see at the top of the debian/rules file)
        # for the exact list of files and folders
	rm -Rf `cat $(UNUSED_FOLDERS)`
	rm -Rf `cat $(CLEANUP_FOLDERS)`
	rm -Rf `cat $(UNNEEDED_BACKUPS)`

	# copy to-be-preserved files back into code tree
	cp -av .preserve/* .
	rm -Rf .preserve/

	LOCAL_LDFLAGS="$(LDFLAGS)" SHLIBGLOBALSFLAGS="$(LDFLAGS)" SHLIBDIR="$(LIBDIR)" PREFIX=/usr dh_auto_build --parallel

override_dh_strip:
	dh_strip -plibnx-x11-6 --dbg-package=libnx-x11-6-dbg
	dh_strip -plibnx-xau6 --dbg-package=libnx-xau6-dbg
	dh_strip -plibnx-xcomposite1 --dbg-package=libnx-xcomposite1-dbg
	dh_strip -plibnx-xdamage1 --dbg-package=libnx-xdamage1-dbg
	dh_strip -plibnx-xdmcp6 --dbg-package=libnx-xdmcp6-dbg
	dh_strip -plibnx-xext6 --dbg-package=libnx-xext6-dbg
	dh_strip -plibnx-xfixes3 --dbg-package=libnx-xfixes3-dbg
	dh_strip -plibnx-xinerama1 --dbg-package=libnx-xinerama1-dbg
	dh_strip -plibnx-xpm4 --dbg-package=libnx-xpm4-dbg
	dh_strip -plibnx-xrandr2 --dbg-package=libnx-xrandr2-dbg
	dh_strip -plibnx-xrender1 --dbg-package=libnx-xrender1-dbg
	dh_strip -plibnx-xtst6 --dbg-package=libnx-xtst6-dbg
	dh_strip -plibxcomp3 --dbg-package=libxcomp3-dbg
	dh_strip -plibxcompshad3 --dbg-package=libxcompshad3-dbg
	dh_strip -plibxcompext3 --dbg-package=libxcompext3-dbg
	dh_strip -pnxagent --dbg-package=nxagent-dbg
	dh_strip -pnxproxy --dbg-package=nxproxy-dbg
	dh_strip -pnxauth --dbg-package=nxauth-dbg
